// System.hxx
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(SYSTEM_HXX__INCLUDED) // {
#define SYSTEM_HXX__INCLUDED

#include "LongUDPSocket.hxx"
#include "Config.hxx"
#include "RescueObjectPool.hxx"
#include "Address.hxx"
#include "LongUDPSocket.hxx"
#include "Input.hxx"
#include "Output.hxx"

namespace Rescue
{
	/////////////////////////////////////////////////////////////////////////
	// System
	
	class Agent;
	/** kernel ̃RA */
	class System
	{
	private:
		
	protected:
		/** oCiOt@C */
		FILE* m_logFile;

		/** ʑΉp\Pbg */
		LongUDPSocket* m_publicSocket;
		/** G[WFgΗp\Pbg */
		LongUDPSocket* m_agentSocket;
		/** V~[^Ηp\Pbg */
		LongUDPSocket* m_simulatorSocket;
		/** GISΗp\Pbg */
		LongUDPSocket* m_gisSocket;
		/** ݒǗ */
		Config m_config;
		/** V~[VĚݎ(P:V~[VTCN) */
		S32 m_time;
		/** kernel ̌ݎ(Pms) */
		long m_systemTime;
		/** VXeׂẴIuWFNg̏W */
		RescueObjectPool m_objectPool;
		/** Mobt@ */
		Input m_inputBuffer;
		/** Mobt@ */
		Output m_outputBuffer;
		/** AhX̃Xg */
		typedef std::list<Address> Addresses;
	public:
		/** Ack ҂IuWFNg */
		class AckWaiter {
		public:
			virtual ~AckWaiter() { }
			virtual void send() = 0;	// ack ҂郁bZ[W̑MBtime ̍XV͌ĂтsƁB
		};
	protected:
		/** simulator ̃AhX Ack ҂IuWFNgւ̃}bv */
		typedef std::map<Address, AutoPtr<AckWaiter> > AddressToAckWaiter;
		AddressToAckWaiter m_addressToAckWaiter;
		/** agent  ID  Ack ҂IuWFNgւ̃}bv */
		typedef std::map<Id, AutoPtr<AckWaiter> > IdToAckWaiter;
		IdToAckWaiter m_idToAckWaiter;

		/** ڑ̂V~[^̃AhX̃Xg */
		Addresses m_simulators;
		/** ڑĂGIS̃AhX */
		Address m_gis;
		/** agent IuWFNg TypeID ̃Xg */
		std::vector<TypeId> m_agentTypes;
		/** Agent IuWFNg̃Xg^ */
		typedef std::list<Agent*> Agents;
		/** ڑ̂Ȃ Agent IuWFNg̃Xg */
		Agents* m_pFreeAgents;
		/** ڑ̂ Agent IuWFNg̃Xg */
		Agents* m_pConnectedAgents;
		/** ݎs悤ƂĂR}h̎ޕʂ Agent ̃Xg */
		typedef std::map<Header, Agents> HeaderToAgents;
		HeaderToAgents m_commandToAngents;
		
		/** G[WFg̐ڑ҂ */
		bool startOk();	// V~[VJnĂH
		void setUp();
		bool m_gisConnected;	// GIS ڑ҂ڑȂȂ falseAڑς݂Ȃ trueB
		/** ڑG[WFgVXeɓo^ */
		void addFreeAgent(Agent* agent);
		/** C[vs */
		virtual void loop();
		void loopCore(long& count, int division);

		/** from 烁bZ[W󂯎AB*/
		void receiveMessages(LongUDPSocket& from);
		/** bZ[W1BsׂǂԂB */
		bool processMessage(const LongUDPSocket& from);
		virtual void processCommand(Agent* agent, Header header, S32 size, Input& input, const LongUDPSocket& from);
		void gisConnectOk(const LongUDPSocket& from);
		void agentConnect(const LongUDPSocket& from);
		void agentAcknowledge(const LongUDPSocket& from);
		void agentConnectError(const LongUDPSocket& from, S32 temporaryId, const char* message);
		void simulatorConnect(const LongUDPSocket& from);
		void simulatorAcknowledge(const LongUDPSocket& from);
		
		/** G[WFg֏𑗐M */
		virtual void sendToAngents() = 0;
		/** V~[^֏𑗐M */
		void sendToSimulators();
		/** V~[^EGIS֍XV𑗐M */
		void sendUpdate(S32 time);
		/** Gp */
		void step();

	public:
		virtual ~System();
		System(const std::vector<TypeId>& agentTypes);

		/** ʑΉp\Pbg */
		LongUDPSocket& publicSocket();
		/** G[WFgΗp\Pbg */
		LongUDPSocket& agentSocket();
		/** V~[^Ηp\Pbg */
		LongUDPSocket& simulatorSocket();
		/** GISΗp\Pbg */
		LongUDPSocket& gisSocket();
		/** ݒ */
		Config& config();
		/** VXeׂẴIuWFNg̏W */
		RescueObjectPool& objectPool();

		/* ::main ֓nꂽp^ŃVXeAs */
		void main(int argc, char const* const* argv); //throw(std::exception)
		
	private:
		System(const System& source);
		System& operator= (const System& rhs);
		bool operator== (const System& rhs) const;
	};
	
	/////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#ifdef NDEBUG
#  include "System.inl"
#endif

#endif // } !defined(SYSTEM_HXX__INCLUDED)
